#include "moldyn.h"
#include <stdio.h>

void hloop (float kinetic, int step, int rank, float vx[], float vy[], float vz[], int natm)
{
   extern float vg, wg, kg;
   extern int iprint;
   extern int natoms;
   extern float freex;
   extern float dens;
   extern float sigma;
   extern float tmpx;
   extern float ace, acv, ack, acp;
   extern float acesq, acvsq, acksq, acpsq;
   extern int nequil;
   float e, en, vn, kn, pres;

   e = kg + vg;
   en = e/(float)natoms;
   vn = vg/(float)natoms;
   kn = kg/(float)natoms;
   tmpx = 2.0*kg/freex;
   pres = dens*tmpx + wg;
   pres = pres*sigma*sigma*sigma;

   if (step>nequil) {
      ace += en;
      acv += vn;
      ack += kn;
      acp += pres;
      acesq += en*en;
      acvsq += vn*vn;
      acksq += kn*kn;
      acpsq += pres*pres;
   }

/* If still equilibrating call subroutine to scale velocities */

   if (nequil > step) scalet (kinetic, vx, vy, vz, natm, step);

}
