#include <stdio.h>
#include "moldyn.h"

void set_chunk (int *istart, int wsize, int ibuf[], int *nchunk, int holist[], int p2c[])
{
   extern float ace, acv, ack, acp, acesq, acvsq, acpsq, acksq;
   extern int chnksz, cperb, pperc;
   extern float cfact;
   extern int nprosx, nprosy, nprosz, nstart, where, natoms;
   extern float boxlx, boxly, boxlz;
   extern float bigbuf[];
   FILE *input_file;
   int i;

   printf ("\n PLEASE GIVE CHUNK SIZE");
   scanf  ("%d", &chnksz);
   printf ("\n PLEASE GIVE CLEAR-OUT FACTOR (1.0=ALL)");
   scanf  ("%f", &cfact);
   cfact = min (cfact, 1.0);
   cfact = max (cfact, 0.0);

   chnksz = min (chnksz, wsize/4+1);
   chnksz = min (chnksz, MYBUFSIZ);

   cperb  = min (MYBUFSIZ/chnksz, nprosx*nprosy*nprosz);
   pperc  = (chnksz-2)/6;

   for(i=1;i<=cperb;++i){
      holist[i-1] = i;
      bigbuf[(i-1)*chnksz]   = -1.0;
      bigbuf[(i-1)*chnksz+1] =  0.0;
      p2c[i-1] =  -1;
   }

   *nchunk = 0;

   printf ("\n Chunk size          = %6d", chnksz);
   printf ("\n Chunks in buffer    = %6d", cperb);
   printf ("\n Particles per chunk = %6d", pperc);

   boxlx = 1.0/(float)nprosx;
   boxly = 1.0/(float)nprosy;
   boxlz = 1.0/(float)nprosz;

   if (nstart == 3) {
      ibuf[0] = -1;
      ibuf[1] =  1;
      where   = 1;
   }
   else if (nstart == 5) {
      input_file = fopen ("checkpointseq.for", "r");
      fscanf (input_file,"%8d%8d%8d",&natoms, istart, &where);
      fscanf (input_file,"%18e%18e%18e%18e%18e%18e%18e%18e",
            &ace, &acv, &ack,&acp, &acesq, &acvsq, &acksq, &acpsq);
      ibuf[0] = *istart;
      ibuf[1] = where;
   }
   else if (nstart == 6) {
      printf ("\n Sorry - unformatted warm starts not yet implemented");
   }
}
